using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using System.Linq;
using UnityEngine.SceneManagement;

namespace ControlSea
{
    public class ControlSea
    {
        public static void OnLoad()
        {
            Map ContSea = ScriptableObject.CreateInstance<Map>();
            ContSea.name = "Controlled Sea";
            ContSea.UniqueIdentity = Guid.NewGuid().ToString();
            ContSea.Description = "Allows the K and I buttons to raise and lower the sea level!";
            ContSea.Thumbnail = ModAPI.LoadSprite("maplogo.png");
            ContSea.Preview = ModAPI.LoadSprite("maplogo.png");
            ContSea.Prefab = MapRegistry.GetAllMaps().ElementAt(6).Prefab;
            MapRegistry.Register(ContSea);
        }



        public static void Main()
        {
            ModAPI.Register<OnLoadMap>();

        }
        public class ControlWatFirstPhase : MonoBehaviour
        {
            public GameObject sea;
            public bool isMapSea = false;
            void Start()
            {
                foreach (GameObject gameObject in UnityEngine.Object.FindObjectsOfType<GameObject>())
                {
                    Component[] components = GetComponents<Component>();
                    var obj = gameObject.name;
                    if (gameObject.name == "Ocean map(Clone)")
                    {
                        isMapSea = true;
                    }
                }
                if (isMapSea == true)
                {
                    foreach (GameObject gameObject in UnityEngine.Object.FindObjectsOfType<GameObject>())
                    {
                        Component[] components = GetComponents<Component>();
                        var obj = gameObject.name;
                        if (gameObject.name == "Sea")
                        {
                            if (gameObject.GetComponent<ControllingSea>() == null)
                            {
                                //gameObject.GetComponent<SpriteRenderer>().sprite = null;
                                sea = gameObject;
                                var a = gameObject.AddComponent<ControllingSea>();
                                a.sea = gameObject;
                            }
                            else
                            {
                                ModAPI.Notify("amogus");
                            }
                        }
                    }
                }
                if (isMapSea == false)
                {
                    ModAPI.Notify("You can't use this object not on the Sea map!");
                }
                GameObject.Destroy(gameObject);
            }
        }
        public class ControllingSea : MonoBehaviour
        {
            public GameObject sea;
            Vector3 maxHeight = new Vector3(521.5f, -52.4f, 0.0f);
            Vector3 minHeight = new Vector3(521.5f, -154.5f, 0.0f);
            void FixedUpdate()
            {
                if (sea.transform.position.y < maxHeight.y && sea.transform.position.y > minHeight.y)
                {
                    if (Input.GetKey(KeyCode.I))
                    {
                        var x = sea.transform.position.x;
                        var y = sea.transform.position.y;
                        var z = sea.transform.position.z;
                        sea.transform.position = new Vector3(x, y + 0.2f, z);
                    }
                    if (Input.GetKey(KeyCode.K))
                    {
                        var x = sea.transform.position.x;
                        var y = sea.transform.position.y;
                        var z = sea.transform.position.z;
                        sea.transform.position = new Vector3(x, y - 0.2f, z);

                    }

                }
                if (sea.transform.position.y > maxHeight.y)
                {
                    sea.transform.position = new Vector3(521.4f, -53f, 0.0f);
                }
                if (sea.transform.position.y < minHeight.y)
                {
                    sea.transform.position = new Vector3(521.5f, -153.4f, 0.0f);
                }
            }
            void OnDestroy()
            {
                GameObject a = new GameObject("mogus");
                a.AddComponent<ControlWatFirstPhase>();
            }
        }
        public class OnLoadMap : MonoBehaviour
        {
            Transform Root;
            void Start()
            {
                if (MapLoaderBehaviour.CurrentMap.name == "Controlled Sea" || MapLoaderBehaviour.CurrentMap.name == "Acid Sea")
                {
                    Root = GameObject.Find("Root").transform;
                    GameObject a = new GameObject("mogus");
                    a.AddComponent<ControlWatFirstPhase>();
                }
            }
        }
    }
}
